;------------------------------------------------------------------------------------------------
;  Net2BBS Telnet Server
;  Version 1.0.2
;  Written by Mike Ehlert, PC Micro Systems, Inc. 
;  http://pcmicro.com
;  Released as Public Domain, Open Source Code.
; 
;  Compile in MASM32, using "Console Assemble and Link"
;------------------------------------------------------------------------------------------------
.686
.model flat,stdcall
option casemap:none
   include \masm32\include\windows.inc	; Windows
   include \masm32\include\user32.inc	; User
   include \masm32\include\kernel32.inc	; Kernel
   include \masm32\include\ws2_32.inc	; Winsock 2.0
   include \masm32\include\winmm.inc	; MultiMedia play functions
   include \masm32\include\masm32.inc	; MASM32
   include \masm32\macros\macros.asm	; MASM32 Macros
   include \masm32\include\comctl32.inc	; CommonControls (only used for InitCommonControls)

   includelib \masm32\lib\user32.lib	; User
   includelib \masm32\lib\kernel32.lib	; Kernel
   includelib \masm32\lib\ws2_32.lib	; WinSock 2.0
   includelib \masm32\lib\winmm.lib       ; MultiMedia play functions
   includelib \masm32\lib\masm32.lib	; MASM32
   includelib \masm32\lib\msvcrt.lib	; C library (only used for getkey)
   includelib \masm32\lib\comctl32.lib	; CommonControls
    
   StartServer     proto
   AcceptThread    proto :DWORD
   SpawnNodeThread proto :DWORD
   Shell           proto :DWORD,:DWORD
   SetTextColor    proto :DWORD,:DWORD
   AppPath         proto :DWORD
   Replace         proto :DWORD,:DWORD,:DWORD,:DWORD	
   LogRefused      proto :DWORD,:DWORD,:DWORD,:DWORD
   GetFromIni      proto :DWORD,:DWORD,:DWORD,:DWORD
   PlayWav         proto :DWORD
   readmyfile      proto :DWORD    
   WriteLog        proto :DWORD,:DWORD
   WildMatch       proto :DWORD,:DWORD


; For reading console keyboard without using msvcrt
;_INPUT_RECORD STRUCT
;	 EventType   WORD ?
;	 WORD ? 		   ; For alignment
;	 UNION
;	     KeyEvent		   KEY_EVENT_RECORD	     <>
;	     MouseEvent 	   MOUSE_EVENT_RECORD	     <>
;	     WindowBufferSizeEvent WINDOW_BUFFER_SIZE_RECORD <>
;	     MenuEvent		   MENU_EVENT_RECORD	     <>
;	     FocusEvent 	   FOCUS_EVENT_RECORD	     <>
;	   ENDS
;_INPUT_RECORD ENDS

.data

   TCPport     dd 23		; Default TCP port = 23   
   StartNode   dd 1		; First node to use
   MaxNodes    dd 256		; Maximum number of nodes
   LastNode    dd 256		; Last node number (startnode+maxnodes-1)
   zero        dd 0
   one         dd 1	
   val4096     dd 4096
   ActiveNodes dd 0		; Number of currently active nodes
   wsa2size    dd SIZEOF wsa2	; sockaddr_in
   DebugMode   db "0",0
   StopFlag    db 0		; Turn this Flag on to stop telnet session
   fMtStrinG   db "%lu",0	; used by wsprintf


   Net2BBSTitle   db  "Net2BBS Telnet Server",0
   IniFileName	db  "net2bbs.ini",0   ; Name of .INI file
   curpath        db  "./",0		    ; Path of notepad or other editor
   IniSectionName db  "Settings", 0	    ; [Settings] is our .INI Section
   DateTxt        db  "00-00-0000 "	    ; Date Format for WriteLog
   TimeTxt        db  "00:00:00"	    ; Time Format for WriteLog

					    ; The following are log file messages:
   Node_            db  "Node ",0
   ConnectTxt       db  "Incoming connection.",0
   ResolvedTxt      db  "Hostname: ",0
;   NotResolvedTxt   db  "IP Unresolvable.",0
   UnknownTxt       db  "Unknown",0
   OpenedTxt        db  " opened.",0
   ClosedTxt        db  " closed.",0
   RefusedTxt       db  "Refused (",0
   Refused1Txt      db  "All Nodes in use).",0 
   Refused2Txt      db  "Semaphore exists).",0 
   Refused3Txt      db  "Matched kill list).",0
   BUSYtxt          db  "BUSY",10,13,0

   logonwav         db  "logon.wav",0    ; Play this sound during a new logon (if it exists)
   logoffwav        db  "logoff.wav",0   ; Play this sound during a logoff (if it exists)
   BBSTitle         db  "BBS node "      ; The Title of an active BBS node window
   BBSTitleNode     db   "   ",0         ; Room to add the node number
   spacestring      db  " ",0            ; string spacer
   ANSIClear        db  01Bh,"[2J"       ; ANSI command to clear the remote screen
   HitEscAgainTxt   db  10,10,10,10,10,9,9,"Press ESC to exit, or any other key to resume "

   ntext	  db  "*n",0 ; Command Line Macro to replace with Node value	(must be lower case here)
   htext	  db  "*h",0 ; Command Line Macro to replace with Handle value	(must be lower case here)  
   IPtext	  db  "*i",0 ; Command Line Macro to replace with IP Address	(must be lower case here)
   restext	  db  "*r",0 ; Command Line Macro to replace with resolved name (must be lower case here)   

.data?
   INI_ADDR	  dd ?	      ; Address of NET2BBS.INI
   hInSock	  dd ?	      ; Handle of Incoming Socket
   hProcess	  dd ?	      ; Handle of main process
   hAcceptThread  dd ?	      ; Handle of Accept Thread
   ThreadID	  dd ?	      ; Thread ID is not used currently (write only)
;  hStdIn	  dd ?	      ; Handle of Standard Input - not used
   hStdOut	  dd ?	      ; Handle ot Standard Output - Needed for Color text 
   hLogFile	  dd ?	      ; Handle of the Log File
   written	  dd ?	      ; Bytes written to log file - Not currently used (write only)
   ShowMode	  dw ?	      ; SW_NORMAL - SW_MINIMIZE - SW_HIDE - or 255 for MAXIMIZE

   SysTime SYSTEMTIME  <?>    ; Used by GetLocalTime
   sinfo   STARTUPINFO <?>    ; Used for shell
   pinfo   PROCESS_INFORMATION <?> ; Used for shell

   wsd WSADATA      <?>       ; Winsock data structure
   wsa sockaddr_in  <?>       ; Winsock primary   sockaddress_inbound structure
   wsa2 sockaddr_in <?>       ; Winsock secondary sockaddress_inbound structure

   nodetable       db 256 dup (?) ; This table defines which nodes are in use(1) or inactive(0).
   buff2           db 128 dup (?) ; This buffer should be removed
   CommandTxt      db 128 dup (?) ; Spawn Command line provided in server.ini
   StartPath       db 128 dup (?) ; Start Path
   KillFileName    db 128 dup (?) ; List of blocked IP's
   KillMsg         db 128 dup (?) ; Text to show a blocked IP
   KillMsgFileName db 128 dup (?) ; Kill Message FileName
   EditorName      db 128 dup (?) ; Editor Filename used for Kill List
   LogFileName     db 128 dup (?) ; Log FileName
   SemFileName     db 128 dup (?) ; Semephore FileName
   ResolveMsg      db 128 dup (?) ; Message shown to user at connect
   View            db  10 dup (?) ; View: Normal, Minimize, Maximize, or Hidden 
   TCPportTxt      db   8 dup (?) ; Ascii text of the TCP port (default 23)
   StartNodeTxt    db   6 dup (?) ; Ascii text of the first telnet node number
   MaxNodesTxt     db   6 dup (?) ; Ascii text of the maximum number of telnet connections
   ResolveMode     db   ?         ; Ascii "0"=disable, "1"=enable - Resolve IP address to hostname 
   temp            dd   ?         ; Temporary dword used by FillConsoleOutputAttribute
   
;------------------------------------------------------------------------------------------------
.code

start:
;	invoke InitCommonControls  ; This is not needed, but helps prevent AntiVirus checkers from false-positive. 
	invoke StartServer
	invoke ExitProcess,0
	
;------------------------------------------------------------------------------------------------
; StartServer - Tell Winsock to Accept TCP connections, each in a new thread
  StartServer proc

	call   InitConsole						    ; Init Console mode and clear screen
	invoke FillConsoleOutputAttribute,hStdOut,00,80*25,NULL,ADDR temp   ; Force the screen to clear black
	invoke FillConsoleOutputAttribute,hStdOut,31,80*2,NULL,ADDR temp    ; Create blue background color at top
	invoke SetTextColor,10,1
	print " -=Net2BBS=- "
	invoke SetTextColor,15,1
	print "Telnet Server v1.02",10,10,13
	
	call GetSettingsFromIni 	; Read the INI file and process it
	jnc iniok
	jmp error_exit			; exit if INI file not found
iniok:	
	invoke memfill, ADDR nodetable, sizeof nodetable, 0 ; Zero fill Node table
	
	invoke atodw,addr TCPportTxt	; Save the provided TCP port if its non-zero
	or eax,eax
	jz keep23			; otherwise default to TCP port 23
	mov TCPport,eax
keep23:
	invoke atodw,addr StartNodeTxt	 ; Save the start node if its non-zero
	or eax,eax
	jz keep1
	mov StartNode,eax
keep1:
	invoke atodw,addr MaxNodesTxt	; Save the max nodes if its non-zero
	or eax,eax
	jz keep256
	mov MaxNodes,eax
keep256:
	mov eax,StartNode
	add eax,MaxNodes
	dec eax
	mov LastNode,eax		; Define LastNode (StartNode+MaxNodes-1)
	cmp byte ptr DebugMode,"0"
	je Main

	print "Debug: Command="
	invoke StdOut,ADDR CommandTxt
	print  " ",10,13

Main:
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Main Telnet Section
; Here's how it works:
;
; Winsock Startup.
; "Socket" to get socket Descriptor.
; "htons" to convert TCP port from decimal to network bytes.
; "Bind" to own a TCP port.
; "Listen" for incoming connections on port.
; "CreateProcess" to handle each connection in its own thread.
;
; Once thats done, just wait for the ESC key to be pressed to exit.
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	invoke SetTextColor,12,0			 ; Color=Red

	invoke WSAStartup,0202h,addr wsd		 ; Enable WinSock version 2
	.if eax!=NULL				 ; Check for error   
	     print "WSock Error"
	jmp error_exit
	.endif

	invoke socket,AF_INET,SOCK_STREAM,IPPROTO_TCP	; "Socket" sets us up the descriptor
	mov	hInSock, eax			    ; save socket descriptor handle


;************************ Experimental Socket Buffer Size adjustment ****************************
; Tested two methods of defining recvbuf and sendbuf sizes... no noticable improvments found
;
; ;;invoke setsockopt,hInSock,IPPROTO_TCP,SO_RCVBUF,offset val4096,SIZEOF val4096  ; set recvbuf	
; invoke setsockopt,hInSock,SOL_SOCKET,SO_RCVBUF,offset val4096,SIZEOF val4096	; set recvbuf	
;
;   .if eax!=NULL
;	print "Set Recv Size failed"
;	jmp error_exit
;   .endif
;
;  ;;invoke setsockopt,hInSock,IPPROTO_TCP,SO_SNDBUF,offset val4096,SIZEOF val4096  ; set sendbuf
;  invoke setsockopt,hInSock,SOL_SOCKET,SO_SNDBUF,offset val4096,SIZEOF val4096  ; set sendbuf
;	.if eax!=NULL
;     print "Set Send Size failed"
;   jmp error_exit
;    .endif
;************************************************************************************************


	mov wsa.sin_family, AF_INET 	    ; Set address family
;	mov wsa.sin_addr, INADDR_ANY	     ; use all network interfaces available
	invoke htons,TCPport			    ; Convert port values host/network bytes 
	mov wsa.sin_port, ax		    ; store sin_port to bind		

	invoke bind,hInSock,addr wsa,sizeof sockaddr_in   ; "Bind" to port socket
	.if eax!=NULL					; Check for error
	  print "Can't open TCP port ",7
	  invoke StdOut,ADDR TCPportTxt
	  jmp error_exit
	.endif

;	invoke ioctlsocket,hInSock,FIONBIO,offset one  ; Force non-blocking socket mode
;	This is not needed!	

	invoke listen,hInSock,3			   ; "Listen" for incoming connection (maximum=3) SOMAXCONN
	.if eax!=NULL				   ; Check for error
	   print "Listen Error"
	   jmp error_exit
	.endif

	invoke CreateThread,0,0,offset AcceptThread,0,0,addr hAcceptThread ; Create 1 Thread to accept new users

waitkey:
	getkey      ; get a key press
	cmp al,01Bh	; test for ESC
	je gotesc
	or al,020h	; force lower-case result
	cmp al,"e"	; test for "E" or "e"
	jne waitkey	; loop

gote:
	; "e" was pressed - Run the editor and pass the name of the block list

	invoke CreateProcess, NULL, ADDR EditorName, NULL, NULL, TRUE,
			      CREATE_NEW_CONSOLE Or NORMAL_PRIORITY_CLASS,
			      NULL,ADDR curpath,addr sinfo,addr pinfo 
	jmp short waitkey

gotesc:
	; ESC was pressed - Display a separate console buffer with a Red background:

	invoke	SetTextColor,15,4   ; Red on White Text
	invoke	CreateConsoleScreenBuffer,GENERIC_READ OR GENERIC_WRITE,0,0,CONSOLE_TEXTMODE_BUFFER,0
	mov	ebx,eax 	    ; Save Handle of Screenbuffer in ebx
; not needed	   invoke  FillConsoleOutputAttribute,ebx,70,2000,NULL,ADDR temp ; Create Red background color
	invoke	WriteConsole,ebx,ADDR HitEscAgainTxt, sizeof HitEscAgainTxt, ADDR written, NULL ;
	invoke	SetConsoleActiveScreenBuffer, ebx
	invoke	SetTextColor,10,0 ; Bright Green

	getkey			; Get second key
	push eax
	invoke CloseHandle,ebx	; close the red console buffer first (1.02 fix for Win 7)
	pop eax
	cmp al,01Bh		; ESC key?
	je cleanup		; If so, cleanup and exit
	jmp waitkey		; otherwise return to main wait

error_exit:
	invoke SetTextColor,15,0	; Color= White
	print " ",10,13,"*** Press Enter to Exit ***"
gel:
	getkey ;was call getanykey
	cmp eax,13
	jne gel

	;invoke locate,0,6	; Delete the "Press Enter"
	;print "                           "

cleanup:
	mov    StopFlag,1		; Tell AcceptThread its time to stop
	invoke Sleep,210		; Wait for AcceptThread to die
	invoke shutdown,hInSock,SD_BOTH ; shutdown socket
	invoke	closesocket,hInSock	; Close socket
	invoke	WSACleanup		; Cleanup Winsock
	invoke SetTextColor,15,0	; Set White on black text
	ret				; Exit
StartServer endp

;------------------------------------------------------------------------------------------------
;************************************************************************************************
;------------------------------------------------------------------------------------------------
  AcceptThread proc near param:dword

; AcceptThread - This is the thread which will accept incoming connections,
;		 and hands each one off to their own SpawnNode Thread 
;
	invoke SetTextColor,7,0
	print	"Waiting for connections on port "
	mov	eax,TCPport
	invoke	dw2a,eax,ADDR TCPportTxt
	invoke	StdOut,ADDR TCPportTxt

	print ".",10,13,"Press ESC to exit, or press [E] to edit blocked IP list.",10,10,13
	invoke	  SetTextColor,10,0

AT_loop:
	invoke accept,hInSock,ADDR wsa2, ADDR wsa2size ; "Accept" a new incoming connection.
				    ; wsa2=buffer for incoming ip
	.if eax!=INVALID_SOCKET       ; If socket is good, Create the Thread. 
	    invoke CreateThread,0,0,offset SpawnNodeThread,eax,0,addr ThreadID ; eax is the winsock handle
	.endif
	invoke Sleep,200	       ; sleep a while
	cmp StopFlag, 0	       ; is thread being told to stop ?
	je AT_loop		       ; if not, loop
	invoke closesocket,hInSock    ; close the socket
	ret			       ; Exit
AcceptThread endp


;------------------------------------------------------------------------------------------------
;************************************************************************************************
;------------------------------------------------------------------------------------------------
  SpawnNodeThread proc hSock:dword

; SpawnNodeThread - This thread is created for each connection and spawns NetFoss

;----------------------------	
local hDupeSock:dword	    ; The Duplicate Socket Handle
local Node:dword  	    ; Node number for this thread
local pMem:dword  	    ; Allocated Memory Buffer Handle for Blocked List
local rpos:dword  	    ; Position in Blocked IP File
local pHostIPAddr:dword     ; pointer to the Host IP Address (non-dotted)
local pHostName:dword	    ; pointer to the resolved HostName
local myIPTextAddr:dword    ; This will contain address to myIPText!
local NodeTxt[6]:byte	    ; Node number in ascii
local HandleTxt[6]:byte     ; Handle number in ascii
local TempBuff1[128]:byte   ; Temp buffers to replace command line macros
local TempBuff2[128]:byte   ; 
;----------------------------

	mov eax,wsa2.sin_addr	; Save the Internet Host Address
	mov pHostIPAddr,eax
	invoke inet_ntoa,eax	; Convert Internet Host Addr to dotted IP addr
	mov myIPTextAddr,eax

	lea edi,buff2				    ; Set EDI pointer to start of buffer
	invoke lstrcpy,edi,ADDR ConnectTxt	    ; Copy "Incoming connection." text to buffer
	add edi,sizeof ConnectTxt-1		    ; point EDI to end
	invoke WriteLog, ADDR buff2, myIPTextAddr   ; Write it to log (and to screen)
	xor eax,eax ; 1.01 bugfix		    ; Zero Node value for now	
	mov Node,eax
	mov pHostName, offset UnknownTxt	    ; Set default hostname text in case resolve fails
	cmp byte ptr ResolveMode,"0"		    ; Check if ResolveIP mode enabled
	je skipresolve				    ; Get out if not

	mov ebx,len(ADDR ResolveMsg)
	invoke send,hSock,ADDR ResolveMsg,ebx,0    ; Write the ResolveMsg text to the socket
	invoke gethostbyaddr,ADDR pHostIPAddr,4,AF_INET ; resolve HostIP Value into hostname

	lea edi,buff2

	mov ebx, offset UnknownTxt			; Assume IP won't resolve
	test eax,eax
	jz skipit

;	 .if eax==NULL
;	    ; mov pHostName,eax    ; If a hostname was not found, zero it
;	    invoke lstrcpy,edi,ADDR NotResolvedTxt   ; Copy "IP won't resolve" text to buffer (CHANGED in 1.01)
;	    add edi,sizeof NotResolvedTxt-1	     ; point EDI to end
;	    ;xor ebx,ebx
;	    jmp short showresolve
;mov ebx,    offset UnknownTxt		  ; Set default hostname text in case resolve fails
;jmp short skipit

;	 .endif

	mov ebx,[eax].hostent.h_name
skipit:
	invoke lstrcpy,edi,ADDR ResolvedTxt	    ; Copy "IP name: " text to buffer
	add edi,sizeof ResolvedTxt-1		    ; point EDI to end
	invoke lstrcpy,edi,ebx			    ; Copy Hostname text to buffer
	add edi,len(ebx) ;(pHostName)		    ; point EDI to end
	mov pHostName,ebx
showresolve:
	invoke WriteLog, ADDR buff2, myIPTextAddr   ; Write it to log (and to screen)
skipresolve:

	lea edi,buff2		    ; Set EDI pointer to start of buffer
	cmp byte ptr SemFileName,0  ; Is Semephore file defined?
	je  check_blockfile	    ; skip if none
	
; If there is a semaphore file, send it to winsock and refuse user.

	invoke	readmyfile, offset SemFileName			; Read the entire semephore file		 
	jc check_blockfile					; Skip if it's not there
	invoke	send,hSock,esi,ecx,0				; Write the semephore file to the socket
	invoke	GlobalFree,esi					; free the allocated memory
	invoke	LogRefused,ADDR buff2, ADDR Refused2Txt,sizeof Refused2Txt-1, myIPTextAddr ; Note Sem Refusal in Log
	jmp close						; and close connection

check_blockfile:

;Check if the users IP or hostname exists within our file list of blocked IP's
;Open and read the KillFile

	invoke readmyfile, ADDR KillFileName
	jc noblockfile	    ; get out if the file was not found
	mov pMem,esi	    ; save the file pointer in pMem

	xor eax,eax	    ; start at the first line (position 0)
	mov rpos,eax
	jmp short linein
	
readloop:
	xor eax,eax	    ; check if rpos=0, if so we are done
	cmp rpos,eax
	je blockdone
linein:
	mov rpos, linein$(pMem,ADDR TempBuff1,rpos) ; This macro reads a line, and updates position

; Before we run the WildMatch, we should remove any spaces from the end of line
; (another idea: could remove spaces from entire line)

	invoke lstrlen,ADDR TempBuff1	    ; Get Length of string
	test eax,eax			    ; zero?
	jz readloop			    ; skip empty line
	mov ebx,eax
kill_trailing:
	cmp byte ptr TempBuff1[ebx], " "    ; look for a space
	jne notspace
	dec ebx 			    ; loop till all checked
	jnz kill_trailing
	jz readloop ; if the line is empty, skip the wildmatch on this line

notspace:
	mov byte ptr TempBuff1+1[ebx],0     ; define the end-of-line with a zero
;	 invoke StdOut,ADDR TempBuff1
;	 print "killed spaces",10,13


; Future Idea: could check if first character is either a plus or minus
; + = always allow this ip (takes priority).
; - = deny this ip (assumed)
; if an IP was explecitly allowed using +, then always allow it even if there is a deny *.
; 
; so when a + is found that matches, end the search
; when a deny is found that matches, set the result as fail, and continue searching.
; at the end of search, check result


	invoke WildMatch, ADDR TempBuff1, myIPTextAddr	; Compare Line with dotted IP text
	test al,al					; got a match?
	jnz gotwild
	cmp byte ptr ResolveMode,"0"			; Check if resolving hostnames
	je readloop					; get out if not

	xor eax,eax					; check if hostname is defined					   
	cmp pHostName,eax
	je readloop					; get out if not

	invoke WildMatch, ADDR TempBuff1, pHostName	; Compare Line with HostName
	test al,al					  ; got a match?
	jz readloop	  
gotwild:
; Here we found a match, so send the killmsg (or killfile) and disconnect the user

	invoke readmyfile, offset KillMsgFileName	; attempt to read killmsg file		  
	jc nokillmsgfile				; skip if it doesnt exist
	invoke send,hSock,esi,ecx,0			; Write the KillMsg file to the socket
	invoke GlobalFree,esi				; free the killmsg file allocated memory
	jmp short killfinish

nokillmsgfile:
	invoke send,hSock,ADDR KillMsg,sizeof KillMsg,0	  ; Write the unwelcome text to the socket
killfinish:
	invoke LogRefused,ADDR buff2, ADDR Refused3Txt,sizeof Refused3Txt-1, myIPTextAddr ; Note the Log
	invoke GlobalFree,pMem 	; free the killallocated memory
	jmp close			; and close connection

blockdone:
	invoke GlobalFree,pMem		; free the allocated memory

noblockfile:
findnode:
	mov ebx, offset nodetable	; Point EBX to nodetable, indexed with ECX
	mov ecx,StartNode
	dec  ecx
findnode1:
	cmp byte ptr [ebx+ecx],0	; Is node in use?
	je foundnode			; If not then claim it
	inc ecx 			; next
	cmp ecx,LastNode		; only check up to Last Node
	jne findnode1			; loop

	invoke LogRefused, ADDR buff2, ADDR Refused1Txt,sizeof Refused1Txt-1, myIPTextAddr ; All nodes are in use

	invoke send,hSock,addr BUSYtxt,sizeof BUSYtxt,0    ; Tell user BUSY
	jmp close			; Close connection

foundnode:

	inc byte ptr [ebx+ecx]		; Enable this node in the table
	inc ActiveNodes
	inc ecx
	mov Node,ecx			; Convert Node number to ascii
	invoke dw2a,Node,ADDR NodeTxt	; and store in NodeTxt

; Write the Users Connection info to Log file

	invoke lstrcpy,edi,ADDR Node_	; Copy "Node " text to buffer
	add edi,sizeof Node_-1		; point EDI to end
	invoke lstrcpy,edi,ADDR NodeTxt ; Copy Node Number text to buffer
	invoke lstrlen,ADDR NodeTxt	; point EDI to end
	add edi,eax
	invoke lstrcpy,edi,ADDR OpenedTxt	; Copy " opened." text to buffer
	add edi,sizeof OpenedTxt-1	; point EDI to end
	invoke WriteLog, ADDR buff2, myIPTextAddr	; Write it to log (and to screen)

	invoke	  GetCurrentProcess	; Get hProcess number
	mov	  hProcess,eax
      
    ; Duplicate the Socket Handle for the spawned process

	invoke DuplicateHandle,hProcess,hSock,hProcess,addr hDupeSock,0,TRUE,DUPLICATE_SAME_ACCESS  ; Store the dupesockhandle value in ascii
	mov eax,hDupeSock			      ; Store the dupesockhandle
	
	lea ebx, HandleTxt
	invoke dw2a,eax,ebx			      ; Create HandleTxt ascii


; Now NodeTxt and HandleTxt are defined, so replace *N/*H/*I/*R macros on the Command Line

 invoke Replace,ADDR CommandTxt,ADDR TempBuff1,ADDR ntext, ADDR NodeTxt   ; Replace *N with {node}
 invoke Replace,ADDR TempBuff1, ADDR TempBuff2,ADDR htext, ADDR HandleTxt ; Replace *H with {handle}
 invoke Replace,ADDR TempBuff2, ADDR TempBuff1,ADDR IPtext, myIPTextAddr  ; Replace *I with {IP Address}
 invoke Replace,ADDR TempBuff1, ADDR TempBuff2,ADDR restext, pHostName    ; Replace *R with {Resolved text}


; Now Command is in TempBuff2
; Do the same with the StartPath (place in TempBuff1)

 invoke Replace,ADDR StartPath, ADDR TempBuff1,ADDR ntext,ADDR NodeTxt	 ; Replace *N with {node}

	cmp byte ptr DebugMode,"0"
	je skip2
	invoke SetTextColor,2,0	   ; Text = Dark Green
	print " Spawn: "
	invoke StdOut,ADDR TempBuff2
	print " ",10,13
	invoke SetTextColor,10,0	    ; Text = Bright Green
skip2:


; Now spawn NetFoss to take over the connection

	invoke PlayWav,addr logonwav			    ; Play the logon wav
	invoke lstrcpy,ADDR BBSTitleNode,ADDR NodeTxt	    ; Create Title (with node number)

	cmp byte ptr ResolveMode,"0"			    ; Check if ResolveIP mode enabled
	je doshell						    ; Skip Clear if not
	invoke send,hSock,ADDR ANSIClear,SIZEOF ANSIClear,0     ; Send an ANSI clear screen command
doshell:
	invoke Shell, ADDR TempBuff1, ADDR TempBuff2  ; Shell to NF+BBS, passing Path,Command to Spawn
	invoke CloseHandle,hDupeSock		    ; On return, Close Dupe Handle
	mov ebx, offset nodetable
	mov ecx,Node
	dec ecx
	dec byte ptr [ebx+ecx]			 ; Mark node as available in Node Table
	dec ActiveNodes
	invoke PlayWav,addr logoffwav		 ; Play the logoff WAV
close:
	invoke shutdown,hSock,1 ; 		 ; force disconnect
	invoke closesocket,hSock			 ; Close Orig Socket
						       ; Process done
	lea edi,buff2
	cmp Node,0
	je  nonode
	invoke lstrcpy,edi,ADDR Node_	    ; Add "Node 1 closed." line to log
	add edi,sizeof Node_-1		    
	invoke lstrcpy,edi,ADDR NodeTxt	    ; copy Node number text
	invoke lstrlen, ADDR NodeTxt	    ; point EDI to end
	add edi,eax
	invoke lstrcpy,edi,ADDR ClosedTxt	; Copy "closed." text to buffer
	add edi,sizeof ClosedTxt-1 	    ; point EDI to end 
	invoke WriteLog, ADDR buff2, myIPTextAddr	; Write it to the log (and to the screen)
nonode:
	ret
SpawnNodeThread endp

;------------------------------------------------------------------------------------------------
readmyfile proc lpfilename

; This opens a file (if the file already exists), and reads the entire file into memory.
; Exit with Carry Set to indicate an error
; Exit with ESI= Global Memory handle (to be released) if sucessful
; AND ECX= bytes read

local hTempFile
local bytesread

	invoke GetFileAttributes, lpfilename		   ; Check if the file exists
	inc eax
	jz readmyfile_error

	invoke CreateFile,lpfilename,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL
	mov hTempFile,eax
	invoke GetFileSize,hTempFile,NULL	; get the file size
	mov ebx, eax				; ebx=file size
	invoke GlobalAlloc,GMEM_FIXED,ebx	;  allocate at least that much memory
	mov esi, eax				;  Save the memory Handle.
	invoke	ReadFile,hTempFile,		;  Read the Semephore File
		esi,				;  Buffer Address
		ebx,				;  Max Amount to send
		ADDR bytesread, 		;  In: bytes actually read
		NULL				;  overlapped

; Here we should make sure the entire file was read, and try to read the remainder if needed.
; Perhaps we should exit this proce with carry set if there was an error?
		
	invoke CloseHandle, hTempFile		   ; close the file handle
	mov ecx, bytesread			   ; Return bytes read in ECX
	clc
	ret

readmyfile_error:
;print "file not found",10,13
	stc
	ret

readmyfile endp

;------------------------------------------------------------------------------------------------
PlayWav proc lpfilename
; 
; Check if a WAV file exits, and if it does, play it

	invoke GetFileAttributes, lpfilename
	inc eax		; Check that EAX!=-1
	jz NoPlay
	Invoke PlaySound, lpfilename, NULL, SND_FILENAME or SND_ASYNC
NoPlay:
	ret
PlayWav endp

;------------------------------------------------------------------------------------------------
WriteLog proc near lplogbuffer, lpIPTextAddr

; This writes the string passed to it to the log file (and screen), appending the current
; date and time to the beginning, and appends a CR/LF to the end.


local buff1[128]:byte	     ; Temp buffer to write log in

; First append CR/LF and zero to end of custom string:

mov dword ptr [edi],00000A0Dh		; force it as a dword

; Get the Date and Time, and format it.

	invoke GetLocalTime,addr SysTime
	invoke GetTimeFormat,NULL,NULL,addr SysTime,SADD("HH':'mm':'ss "),addr TimeTxt,sizeof TimeTxt
	invoke GetDateFormat,NULL,NULL,addr SysTime,SADD("MM'-'dd'-'yyyy"),addr DateTxt,sizeof DateTxt
	mov byte ptr DateTxt+10," " ; put a space between date and time. 
	lea esi, buff1		  ; Point EDI to buffer
	invoke lstrcpy,esi,Addr DateTxt	; Add Date+Time
	add esi,(sizeof DateTxt) + (sizeof TimeTxt)
	mov ebx,00202D20h		; " - ",0 
	mov [esi],ebx	    		; add it as a dword
	add esi,3
	invoke lstrcpy,esi,lpIPTextAddr	  ; Append the IP Address to buffer
	invoke lstrlen,lpIPTextAddr 	  ; adjust buffer size for IP length
	add esi,eax
	;mov ebx, 00202D20h		  ; 
	mov [esi],ebx			  ; add " - " as a dword
	add esi,3
	invoke lstrcpy,esi, lplogbuffer	  ;ADDR buff2  ; Copy Custom String in Buff2 to Buff1
	lea esi, buff1

	invoke lstrlen,esi		  ; adjust buffer size for IP
	mov ebx,eax ; Store IP Length in ebx

; Write the entire line to the log

	invoke CreateFile,ADDR LogFileName,GENERIC_WRITE,FILE_SHARE_READ,0,
			  OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	mov hLogFile,eax
	invoke SetFilePointer,hLogFile,0,0,FILE_END ; Point to end of log file
	invoke WriteFile,hLogFile,ADDR buff1,ebx,ADDR written,0
	invoke CloseHandle,hLogFile
	invoke StdOut,ADDR buff1	    ; Print it to screen as well
	ret
WriteLog endp
;------------------------------------------------------------------------------------------------

LogRefused proc lplogbuffer:DWORD, lpfilename:DWORD, lpfilesize:DWORD, lpIPTextAddr:DWORD 

	invoke lstrcpy,edi,ADDR RefusedTxt	; Add RefusedTxt to buffer
	add edi,sizeof RefusedTxt-1		; Adjust buffer end pointer 
	invoke lstrcpy,edi,lpfilename		; Add filename to buffer
	add edi,lpfilesize			; Adjust buffer end pointer
	invoke WriteLog, lplogbuffer, lpIPTextAddr	; Write the log entry
	ret
LogRefused endp


;----------------------------------------------------------------------------------------------- 
  Shell proc lppath:DWORD,lpfilename:DWORD 

; Shell - Spawn a process and wait for it to finish
; 
;
; LPCTSTR lpApplicationName,		       null
; LPTSTR lpCommandLine, 		       lpfilename
; LPSECURITY_ATTRIBUTES lpProcessAttributes,   null
; LPSECURITY_ATTRIBUTES lpThreadAttributes,    null 
; BOOL bInheritHandles, 		       true
; DWORD dwCreationFlags,		       create_new_cons+normal_prior
; LPVOID lpEnvironment, 		       null
; LPCTSTR lpCurrentDirectory,		       lppath
; LPSTARTUPINFO lpStartupInfo,		       addr sinfo
; LPPROCESS_INFORMATION lpProcessInformation   addr pinfo

	invoke memfill, ADDR sinfo, sizeof sinfo, 0
	;invoke GetStartupInfo,addr sinfo

	mov sinfo.lpTitle, offset BBSTitle  ; Set the Window Title
	mov sinfo.cb,sizeof sinfo
	mov sinfo.dwFlags, STARTF_USESHOWWINDOW
	mov ax,ShowMode 		    ; Window Show mode: Normal, Minimized, Maximized or Hidden
	cmp al,255 ;255=Maximized (It's not possible to Maximize under Vista) 
	jne doit
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; Force Maximized window by stuffing keyboard events
; This will not work under Windows Vista or later
  invoke keybd_event,VK_MENU,38h,0,0
  invoke keybd_event,VK_RETURN,1Ch,0,0
  invoke keybd_event,VK_RETURN,1Ch,KEYEVENTF_KEYUP,0
  invoke keybd_event,VK_MENU,38h,KEYEVENTF_KEYUP,0
  mov ax,SW_NORMAL
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
doit:
	mov sinfo.wShowWindow, ax
	invoke CreateProcess, NULL, lpfilename, NULL, NULL, TRUE,
			CREATE_NEW_CONSOLE Or NORMAL_PRIORITY_CLASS,
			NULL, lppath, addr sinfo, addr pinfo
	.if eax 
	  invoke GetCurrentProcess
	  push eax
	  invoke SetPriorityClass,eax,IDLE_PRIORITY_CLASS	    ; lower cpu while waiting							     
	  invoke WaitForSingleObject, pinfo.hProcess, INFINITE    ; wait for process to terminate						      

;	  @@: 
;	  invoke GetExitCodeProcess,pr_infox.hProcess,ADDR xc 
;	  invoke Sleep, 10 
;	  cmp xc, STILL_ACTIVE 
;	  je @B 
;	  invoke GetExitCodeProcess, pinfo.hProcess, addr xc      ; get exit code of process 

	  pop eax
	  invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS 
	  invoke CloseHandle, pinfo.hThread			    ; Close open handles
	  invoke CloseHandle, pinfo.hProcess	   
	.endif 
	ret 
Shell endp


;------------------------------------------------------------------------------------------------
; Get settings from net2bbs.ini        ;
;------------------------------------------------------------------------------------------------
GetSettingsFromIni proc uses ebx esi edi

    LOCAL   INI_Path[1024] :BYTE

    CTEXT MACRO text:VARARG
      LOCAL TxtName
      .data
	TxtName BYTE text, 0
      .code
      EXITM <ADDR TxtName>
    ENDM
    
	invoke  AppPath, ADDR INI_Path			; Get path of Application
	invoke lstrcat, ADDR INI_Path, ADDR IniFileName	; Append the Ini FileName to it 	   

	; Make sure ini file can be found, or else we fail.

	invoke GetFileAttributes, addr INI_Path ; Does the .ini file exist?
	inc eax				; -1 means it doesn't exist
	jnz iniread
	invoke SetTextColor,12,0	; color=Red
	print  "Config missing: "
	invoke SetTextColor,7,0		; color=White
	invoke StdOut,ADDR INI_Path
	print " ",13,10
	stc 				; set carry to indicate error and exit
	ret
		
iniread:
	lea eax,INI_Path
	mov INI_ADDR,eax

; GetFromIni uses:  Command Text, default value, Where to place it, maximum size in bytes

 invoke GetFromIni, CTEXT("Command"),   ADDR zero,    ADDR CommandTxt, sizeof CommandTxt
 invoke GetFromIni, CTEXT("StartPath"), ADDR curpath, ADDR StartPath, sizeof StartPath
 invoke GetFromIni, CTEXT("Port"),      CTEXT("23"),  ADDR TCPportTxt,sizeof TCPportTxt
 invoke GetFromIni, CTEXT("Nodes"),     CTEXT("256"), ADDR MaxNodesTxt, sizeof MaxNodesTxt
 invoke GetFromIni, CTEXT("StartNode"), CTEXT("1"),   ADDR StartNodeTxt, sizeof StartNodeTxt
 invoke GetFromIni, CTEXT("Debug"),     CTEXT("0"),   ADDR DebugMode, sizeof DebugMode
 invoke GetFromIni, CTEXT("Resolve"),	CTEXT("0"),   ADDR ResolveMode, sizeof ResolveMode
 invoke GetFromIni, CTEXT("Log"),	CTEXT("telnet.log"), ADDR LogFileName, sizeof LogFileName
 invoke GetFromIni, CTEXT("Editor"),	CTEXT("notepad"), ADDR EditorName, sizeof EditorName
 invoke GetFromIni, CTEXT("KillList"),	CTEXT("kill.txt"), ADDR KillFileName, sizeof KillFileName
 invoke GetFromIni, CTEXT("KillMsg"),	CTEXT("Access Denied."), ADDR KillMsg, sizeof KillMsg
 invoke GetFromIni, CTEXT("KillMsgFile"), ADDR zero,  ADDR KillMsgFileName, sizeof KillMsgFileName
 invoke GetFromIni, CTEXT("Semaphore"),   ADDR zero,  ADDR SemFileName, sizeof SemFileName
 invoke GetFromIni, CTEXT("ResolveMsg"),  ADDR zero,  ADDR ResolveMsg, sizeof ResolveMsg
 invoke GetFromIni, CTEXT("View"),	  ADDR zero,  ADDR View, sizeof View

; View can be: Normal, Minimized, or Hidden. Normal is default, so check for minimize or hidden:

	mov bx,SW_NORMAL	; assume default view
	xor edi,edi
	invoke  lstrcmp, CTEXT("Minimize"), ADDR View
	.if eax == EDI
	  mov bx,SW_MINIMIZE
	.endif
	invoke  lstrcmp, CTEXT("Hide"), ADDR View
	.if eax == EDI
	  mov bx,SW_HIDE
	.endif
	invoke  lstrcmp, CTEXT("Maximize"), ADDR View
	.if eax == EDI
	  mov bx,255
	.endif

	mov ShowMode,bx
	;invoke lstrcat, ADDR KillMsg, ADDR CRLF ; Add CR/LF to end of killmsg?

	invoke lstrcat, ADDR EditorName, ADDR spacestring   ; Add a space to Editor Command Line
	invoke lstrcat, ADDR EditorName, ADDR KillFileName  ; Add KillList to Editor Command Line
	cmp byte ptr DebugMode,"0"
	je inidone
    
debughello:
	invoke SetTextColor,2,0
	print "Debug: Reading "
	invoke StdOut,ADDR INI_Path
	print " ",13,10	   

inidone:
	clc
	ret
GetSettingsFromIni endp

;------------------------------------------------------------------------------------------------
GetFromIni proc near lpCmd:DWORD, lpDefault:DWORD, lpDest:DWORD, DestSize:DWORD

 invoke	GetPrivateProfileString, ADDR IniSectionName, lpCmd, lpDefault, lpDest, DestSize, INI_ADDR
 ret
GetFromIni endp
;------------------------------------------------------------------------------------------------

AppPath proc lpPathBuffer:DWORD

; Get the Application Path

	invoke GetModuleFileName,0,lpPathBuffer,128  ; return length in eax
	add eax, lpPathBuffer
@@:
	dec eax
	cmp BYTE PTR [eax],'\'		; compare if "\"
	jne  @B				; jump back to @@: if not "\"
	mov  BYTE PTR [eax+1],0		; write zero terminator after "\"
	mov  eax, lpPathBuffer
	ret
AppPath endp

;------------------------------------------------------------------------------------------------
InitConsole proc

	Invoke SetConsoleTitle, ADDR Net2BBSTitle

;invoke CreateConsoleScreenBuffer,GENERIC_READ OR GENERIC_WRITE,0,0,CONSOLE_TEXTMODE_BUFFER,0

; There is no need to change the input
;	invoke GetStdHandle,STD_INPUT_HANDLE
;	mov hStdIn, eax
;	invoke SetConsoleMode, hStdIn, ENABLE_PROCESSED_INPUT

	invoke GetStdHandle,STD_OUTPUT_HANDLE
	mov   hStdOut,eax
	cls		  ; Clear the screen
	ret
InitConsole endp


;------------------------------------------------------------------------------------------------
; The procedures below this line were found in public forums and may or may not be public domain!
;------------------------------------------------------------------------------------------------


;------------------------------------------------------------------------------------------------
SetTextColor proc fore:DWORD,back:DWORD
; 
; This proc sets the foreground and background attributes for
; the characters written to the console screen buffer.
;
; The color values are normal 4-bit IRGB character mode
; attributes where:
;   bit3 = intensity
;   bit2 = red
;   bit1 = green
;   bit0 = blue
; 
; The attribute is stored in a single byte.
	mov   eax,back
	shl   eax,4
	or	  eax,fore
	invoke SetConsoleTextAttribute,hStdOut,eax
	ret
SetTextColor endp


;------------------------------------------------------------------------------------------------
; Convert Double-Word to ASCII string
;
; dwValue is passed as a value, direct, indirect or in register
; lpBuffer is the ADDRESS of the receiving buffer
; EXAMPLE:
; invoke dw2a,edx,ADDR buffer

dw2a proc dwValue:DWORD, lpBuffer:DWORD

	invoke wsprintfA,lpBuffer,ADDR fMtStrinG,dwValue
	ret
dw2a endp


;------------------------------------------------------------------------------------------------
; Replace - Text String Search and Replace Function
;
;align 4

Replace proc src:DWORD,dst:DWORD,txt1:DWORD,txt2:DWORD
;  Source String, Dest String, orig text, new text
    LOCAL lsrc	:DWORD

;	push ebx
;	push esi
;	push edi

	mov lsrc, len(src)		; procedure call for src length
	sub lsrc, len(txt1) 	; procedure call for 1st text length

	mov esi, src
	add lsrc, esi		; set exit condition
	mov ebx, txt1
	inc lsrc			; adjust to get last character
	mov edi, dst
	xor eax, eax		; zero EAX
	dec esi
	jmp rpst
; ----------------------------
;  align 4
pre:
    add esi, ecx		; ecx = len of txt1, add it to ESI for next read
;  align 4
rpst:
	inc esi
	cmp lsrc, esi		; test for exit condition
	jle rpout
	mov al, [esi]		; load byte from source
	mov ah,al
	or ah,020h
	cmp ah, [ebx]		; test it agqainst 1st character in txt1
	je test_match
	mov [edi], al		; write byte to destination
	inc edi
	jmp rpst
; ----------------------------
;  align 4
	test_match:
	mov ecx, -1 		; clear ECX to use as index
	mov edx, ebx		; load txt1 address into EDX
@@:
	inc ecx
	mov al, [edx]
	test al, al 		; if you have got to the zero
	jz change_text		; replace the text in the destination
	inc edx
;    cmp [esi+ecx], al		 ; keep testing character matches
	mov ah, [esi+ecx]
	or ah,020h
	cmp ah,al
	je @B
	mov al, [esi]		; if text does not match
	mov [edi], al		; write byte at ESI to destination
	inc edi
	jmp rpst
; ----------------------------
;  align 4
change_text:			; write txt2 to location of txt1 in destination
	mov edx, txt2
	dec ecx
@@:
	mov al, [edx]
	test al, al
	jz pre
	inc edx
	mov [edi], al
	inc edi
	jmp @B
; ----------------------------
;  align 4
rpout:				; write any last bytes and terminator
	mov ecx, -1
@@:
	inc ecx
	mov al, [esi+ecx]
	mov [edi+ecx], al
	test al, al
	jnz @B
;	pop edi
;	pop esi
;	pop ebx
	ret
Replace endp

;------------------------------------------------------------------------------------------------
; WildMatch - Checks if one string exists within another string, supporting wildcards "?" and "*".

WildMatch proc uses ebx esi edi wild :DWORD, string :DWORD

    mov        ecx, wild
    mov        edx, string

    .while BYTE PTR [edx] != 0 && BYTE PTR [ecx] != "*"
	mov	   bl, [ecx]
	mov	   bh, [edx]
	.if bl != bh && bl != "?"
	    xor        eax, eax
	    ret
	.endif
	inc	   ecx
	inc	   edx
    .endw

    .while BYTE PTR [edx] != 0
	mov	   bl, [ecx]
	mov	   bh, [edx]
	.if bl == "*"
	    inc        ecx
	    mov        bl, [ecx]
	    .if bl == 0
		xor	   eax, eax
		inc	   eax
		ret
	    .endif
	    mov        esi, ecx
	    mov        eax, edx
	    inc        eax
	.elseif bl == bh || bl == "?"
	    inc        ecx
	    inc        edx
	.else
	    mov        ecx, esi
	    mov        edx, eax
	    inc        eax
	.endif
    .endw
    
    .while    BYTE PTR [ecx] == "*"
	inc	   ecx
    .endw
    
;    xor eax,eax
    mov al,[ecx]
;    or al,al
;    sete al
    ret
WildMatch endp

end start   
